package com.shekarmudaliyar.social_share

import android.R.attr.path
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.util.Log
import androidx.annotation.NonNull
import androidx.core.content.FileProvider
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import java.io.File


/** SocialSharePlugin */
class SocialSharePlugin(private val registrar: Registrar):  MethodCallHandler {

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "social_share")
      channel.setMethodCallHandler(SocialSharePlugin(registrar))
    }
  }
  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
      if (call.method == "shareInstagramStory") {
          try {
              val stickerImage: String? = call.argument("stickerImage")
              val backgroundTopColor: String? = call.argument("backgroundTopColor")
              val backgroundBottomColor: String? = call.argument("backgroundBottomColor")
              val attributionURL: String? = call.argument("attributionURL")
              Log.d("sticker",Uri.parse(stickerImage).toString())
              Log.d("backgroundTopColor",backgroundTopColor)
              Log.d("backgroundBottomColor",backgroundBottomColor)
              Log.d("attributionURL",attributionURL)
//              var file = File(stickerImage)
//              var uri = Uri.fromFile(file)

//          val file =  File(registrar.activeContext().cacheDir,stickerImage)
//          Log.d("log",registrar.context().packageName)
          val stickerAssetUri = FileProvider.getUriForFile(registrar.activity().getBaseContext(),
                  registrar.activity().getApplicationContext()
                          .getPackageName() + ".provider",  File(registrar.activity().applicationContext.getDir("flutter", Context.MODE_PRIVATE).getPath(),stickerImage))
          Log.d("log",stickerAssetUri.toString())

          val intent = Intent("com.instagram.share.ADD_TO_STORY")
          intent.type = "image/*"
          intent.putExtra("interactive_asset_uri", stickerAssetUri)
          intent.putExtra("content_url", attributionURL)
          intent.putExtra("top_background_color", "#33FF33")
          intent.putExtra("bottom_background_color", "#FF00FF")
//            intent.`package`="com.instagram.android"
//          // Instantiate activity and verify it will resolve implicit intent
//          // Instantiate activity and verify it will resolve implicit intent
//          val activity: Activity = registrar.activity()
//          activity.grantUriPermission(
//                  "com.instagram.android", Uri.parse(stickerImage), Intent.FLAG_GRANT_READ_URI_PERMISSION)
//          if (activity.packageManager.resolveActivity(intent, 0) != null) {
//              activity.startActivityForResult(intent, 0)
//          }
//              val stickerAssetUri: Uri = Uri.parse(stickerImage)
//              val instagram =  Intent(Intent.ACTION_SEND);
//              instagram.setPackage("com.instagram.android");
//             registrar.context().startActivity(instagram);
//              val intent = Intent("com.instagram.android")
//              intent.type = "image/*"
//              intent.putExtra("interactive_asset_uri", stickerAssetUri)
//              intent.putExtra("content_url", attributionURL)
//              intent.putExtra("top_background_color", backgroundTopColor)
//              intent.putExtra("bottom_background_color", backgroundBottomColor)
//              Log.d("", registrar.activity().toString())
//              // Instantiate activity and verify it will resolve implicit intent
//              // Instantiate activity and verify it will resolve implicit intent
              val activity: Activity = registrar.activity()
//              intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
//              activity.startActivity(intent)

              activity.grantUriPermission(
                      "com.instagram.android", stickerAssetUri, Intent.FLAG_GRANT_READ_URI_PERMISSION)
              if (activity.packageManager.resolveActivity(intent,0) != null) {
                  activity.startActivity(intent)
                  result.success("success")
              } else {
                  result.success("error")
              }
          }
          catch (e:Exception){
              Log.d("  ",e.toString())
          }
      } else {
          result.notImplemented()
      }
  }
}
